/*----------------------------------------------------------------------*
    smpl10.c
    Tv10 - Version 1.0
    [TWI]
    Copyright (C) 2006 BestTechnology CO.,LTD.
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  nCp[^[~i̒ʐM\tgɐڑĎgp܂B

  TWI[qɐڑꂽX[u@̔Cӂ̃AhX̃f[^ǂݍ݂܂B
  ----------------------------------------------------------------------
 yڍׁz
  TWI[qɐڑꂽIIC I/F@(24LC64)ɑ΂āACӂ̃AhX
  f[^M܂BIIC@푤SDASCL[qɃvAbvKvłB
  24LC64A0,A1,A2ׂ͂GNDɐڑ܂B
  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <avr/interrupt.h>  // 荞݊֘A
#include <rs.h>             // USARTʐMCu

unsigned char s_addr, status_b;

void TWIError(unsigned char edata)
{
  switch(edata){
    case 0x08:
      rs_printf("0x08 Error\n\r");
      break;
    case 0x18:
      rs_printf("0x18 Error\n\r");
      break;
    case 0x28:
      rs_printf("0x28 Error\n\r");
      break;
    case 0x40:
      rs_printf("0x40 Error\n\r");
      break;
    case 0x58:
      rs_printf("0x58 Error\n\r");
      break;
    default:
      break;
  }
  while(1);
}

unsigned char TWIRead(unsigned char adata, unsigned char tdata)
{
  unsigned char rdata = 0x00;
  
  TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT)));
  if((TWSR & 0xF8) != 0x08) TWIError(0x08);
      
  TWDR = adata;
  TWCR = _BV(TWINT) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT)));
  if((TWSR & 0xF8) != 0x18) TWIError(0x18);
  
  TWDR = tdata;
  TWCR = _BV(TWINT) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT)));
  if((TWSR & 0xF8) != 0x28) TWIError(0x28);
      
  TWCR = _BV(TWSTA) | _BV(TWINT) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT)));
  if((TWSR & 0xF8) != 0x10);
    
  TWDR = adata | 0x01;
  TWCR = _BV(TWINT) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT))){}
  if((TWSR & 0xF8) != 0x40) TWIError(0x40);
  
  TWCR = _BV(TWINT) | _BV(TWEN);
  while(!(TWCR & _BV(TWINT)));
  if((TWSR & 0xF8) != 0x58) TWIError(0x58);
  rdata = TWDR;
  TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTO);
  return rdata;
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void)
{
  TWBR = 0x2C;        // 16MHz / (16 + 2 x (44) x 4) -> 100kHz
  TWSR = _BV(TWPS0);  // 4
  TWCR = _BV(TWEN);   // TWI싖
  
  // ʐM|[g {[[g115200[bps]
  rs_init (br115200);
  
  // ʐM͊荞݂ŏ܂
  // ͕K荞݂ԂɂĂ
  sei ();

  rs_puts ("\n<SMPL10 start>\n");

  rs_printf("READ DATA %x",TWIRead(0xA0, 4));
  rs_printf("\n\r");

  while (1);                     // [v
}
