 /*----------------------------------------------------------------------*
    smpl8.c
    Tv8 - Version 1.0
    [SPI]
    Copyright (C) 2006 BestTechnology CO.,LTD.
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  SPIڑ@8bit/16bitf[^𑗐M܂B

  pӂ֐́A8bit/16bitf[^̑M̂ݍs܂B
  ^[QbgƂȂSPI@ɍ킹āA֐gĂ
  ----------------------------------------------------------------------
 yڍׁz
   SPI_TX8(),SPI_TX16͂ꂼ8bit,16bitf[^𑗐M܂B
  MSPIݗvtOSPIFɂ蔻f܂B

 yӁz
  f[^̑Mɂ͊荞݂gpĂ邽߁AK荞݋sȂ
  B
  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <avr/interrupt.h>  // 荞݊֘A
#include <stdlib.h>
#include <rs.h>             // USARTʐMCu

#define nop()	__asm__ __volatile__("nop")

/*-----------------------------------------------*/
/* EFCg[` (^C}/JE^2gp)     */
/*-----------------------------------------------*/
void wait (unsigned long pause_ms)
{
  unsigned long i;

  TCCR2A = 0x00;
  TCCR2B = 0x00;   // stop
  TCNT2  = 0;      // set count
  OCR2A  = 0xfa;   // set compare
  TCCR2A = 0x02;   // ctc
  TCCR2B = 0x04;   // start timer clk/64  (OCF=976.5625Hz1ms)

  for (i = 0; i < pause_ms; i++) {
    loop_until_bit_is_set(TIFR2, OCF2A);
    TIFR2 |= _BV(OCF2A);
  }
  TCCR2B = 0x00;   // stop
}

void SPI_TX8(unsigned char cData)
{
  PORTB&= ~_BV(PB2);           // SS=0o
  SPDR = cData;                // ްMJn
  while(!(SPSR & _BV(SPIF)));  // ]܂őҋ@
  PORTB|= _BV(PB2);            // SS=1o
  nop();
}

void SPI_TX16(unsigned char cData1,unsigned char cData2)
{
  PORTB&= ~_BV(PB2);           // SS=0o
  SPDR = cData1;               // ްMJn
  while(!(SPSR & _BV(SPIF)));  // ]܂őҋ@
  SPDR = cData2;               // ްMJn
  while(!(SPSR & _BV(SPIF)));  // ]܂őҋ@
  PORTB|= _BV(PB2);            // SS=1o
  nop();
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void)
{
  DDRB = _BV(PINB5) | _BV(PINB3) | _BV(PINB2);
    
  SPCR = 0x51;
  SPSR = 0x00;
  
  // ʐM|[g {[[g115200[bps]
  rs_init (br115200);

  // ʐM͊荞݂ŏ܂
  // ͕K荞݂ԂɂĂ
  sei ();

  rs_puts ("\n<SMPL8 start>\n");

  while (1) {                     // [v
    // SPI_TX8(0xFF);  // ^[Qbgɍ킹đMf[^p
    // SPI_TX16(0xFF,0xFF);  // ^[Qbgɍ킹đMf[^p
    wait(100);
  }
}
